<i18n>
{
  "fr": {
    "title-1": "Se connecter",
    "title-2": "S'enregistrer",
    "label-1": "Email",
    "label-2": "Mot de passe",
    "label-3": "Confirmation du mot de passe",
    "label-4": "Mot de passe oublié ?"
  },
  "en": {
    "title-1": "Login",
    "title-2": "Sign in",
    "label-1": "Email",
    "label-2": "Password",
    "label-3": "Password confirmation",
    "label-4": "Forgot your password ?"
  }
}
</i18n>

<template>
  <div class="modal-card" style="width: auto">
    <section class="modal-card-body">
      <b-tabs position="is-centered">
        <b-tab-item icon="user" :label="$t('title-1')">
          <div class="box-red" v-if="erreurConnect">
              {{ erreurConnect }}
          </div>
          <br v-if="erreurConnect"/>
          <form @submit.prevent="seLoguer()">
            <b-field :label="$t('label-1') + ' *'">
              <b-input v-model="connectUser.email"
                required="required"
                type="email"
                :placeholder="$t('label-1') + ' *'">
              </b-input>
            </b-field>
            <b-field :label="$t('label-2') + ' *'">
              <b-input v-model="connectUser.password"
                type="password"
                required="required"
                :placeholder="$t('label-2') + ' *'"
                password-reveal></b-input>
            </b-field>
            <button
              class="button is-primary
              is-fullwidth"
              type="submit"
            >
              <span class="icon is-small"><i class="sui sui-paper-plane"></i></span>
              <span>{{ $t('title-1') }}</span>
            </button>
            <br />
            <p class="has-text-centered">
              <router-link
                v-on:click.native="motDePasseOublie"
                class="link" :to="{ name: 'reset-password' }"
              >
                {{ $t('label-4') }}
              </router-link>
            </p>
          </form>
        </b-tab-item>
        <b-tab-item icon="pencil" :label="$t('title-2')">
          <div class="box-blue" v-if="linkSent">
            Un <strong>lien d'activation</strong> vous a été <strong>envoyé par email</strong>,
            veuillez cliquer dessus afin d'activer et utiliser votre compte.
          </div>
          <div v-else>
            <div class="box-red" v-if="erreurRegister">
                {{ erreurRegister }}
            </div>
            <br v-if="erreurRegister"/>
            <form @submit.prevent="sEnregistrer">
              <b-field label="Email *">
                <b-input v-model="registertUser.email"
                  type="email"
                  placeholder="Email *">
                </b-input>
              </b-field>
              <b-field :label="$t('label-2') + ' *'">
                <b-input v-model="registertUser.password1"
                  type="password"
                  :placeholder="$t('label-2') + ' *'">
                </b-input>
              </b-field>
              <b-field :label="$t('label-3') + ' *'">
                <b-input v-model="registertUser.password2"
                  type="password"
                  @keydown.enter="validate"
                  :placeholder="$t('label-3') + ' *'">
                </b-input>
              </b-field>
              <button
                class="button is-primary is-fullwidth"
                type="submit"
              >
                <span class="icon is-small"><i class="sui sui-paper-plane"></i></span>
                <span>{{ $t('title-2') }}</span>
              </button>
            </form>
          </div>
        </b-tab-item>
      </b-tabs>
    </section>
  </div>

</template>

<script>
import authenticationService from '@/services/authenticationService'

export default {
  name: 'AuthModal',
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      linkSent: false,
      connectUser: {
        email: null,
        password: null
      },
      registertUser: {
        email: null,
        password1: null,
        password2: null
      },
      erreurConnect: '',
      erreurRegister: ''
    }
  },
  methods: {
    motDePasseOublie () {
      this.$parent.close()
    },
    seLoguer () {
      this.connectUser.email = this.connectUser.email.toLowerCase()
      let { email, password } = this.connectUser
      this.$store.dispatch('authentication/authRequest', { email, password })
        .then(() => {
          this.$parent.close()
        })
        .catch((erreur) => {
          if ('detail' in erreur.response.data) {
            if (erreur.response.data.detail === 'No active account found with the given credentials') {
              this.erreurConnect = 'Votre compte n\'a pas encore été activé, veuillez l\'activer avant de vous connecter.'
            } else {
              this.erreurConnect = 'Si vous n\'êtes pas déjà enregistré.e, créez votre compte. Sinon, votre email et / ou mot de passe sont incorrects. Réessayez ou contactez nous si le problème persiste.'
            }
          } else {
            this.erreurConnect = erreur.response.data
          }
        })
    },
    sEnregistrer () {
      this.registertUser.email = this.registertUser.email.toLowerCase()
      authenticationService.register(this.registertUser)
        .then(data => {
          this.linkSent = true
        })
        .catch((erreur) => {
          if ('email' in erreur.response.data) {
            // this.erreurRegister = erreur.response.data['email'][0]
            this.erreurRegister = 'Un utilisateur avec cet email existe déjà.'
          } else if ('non_field_errors' in erreur.response.data) {
            this.erreurRegister = 'Les deux mots de passes fournis ne sont pas identiques.'
          } else {
            this.erreurRegister = erreur.response.data
          }
        })
    }
  }
}
</script>
